-- turret.love

local atan2, sqrt, pi, floor = math.atan2, math.sqrt, math.pi, math.floor

function love.load()
	vector			= { 400, 300, 400, 0 }	-- vector(centerXY, mouseXY)
	facing_angle	= 0
	rotation_speed	= 2
	turret			= love.graphics.newImage( 'turret.png' )
	love.mouse.setPosition( vector[3], vector[4] )
	end

function love.update( dt )
	vector[3],vector[4] = love.mouse.getPosition()
	facing_angle, done = rotate( vector, facing_angle, dt, rotation_speed )
	end

function rotate( vector, current, dt, speed )
	local x, y, x2, y2 	= unpack( vector )
	local goal = atan2( y2-y, x2-x )
	local diff = ( goal  - current + pi ) % ( 2 * pi ) - pi		-- checking for difference
	if diff >  dt then return current + speed * dt, false end	-- rotate cw
	if diff < -dt then return current - speed * dt, false end	-- rotate cc
	return goal, true 											-- rotation complete
	end

function love.draw()
	love.graphics.print('Facing angle: '..math.floor(math.deg(facing_angle)),10,10)
	love.graphics.draw(turret,vector[1],vector[2],facing_angle+1.54,1,1,90,190)
	love.graphics.line( unpack( vector ) )
	end

function love.keypressed( key )
	if key == 'escape'	then love.event.push( 'quit' )	end
	end
